(* lverem.pas *)

{  Verem (stack) adatszerkezet megvalstsa lista segtsgvel }
{  a listaelem szerkezete: infolink                          }

program lverem;
uses crt;

type
  tadat = word;
  septr = ^selem;
  selem = record
                info : tadat;
	        link : septr;
              end;
const
   pteteje : septr = nil;   { veremmutat, res stack }

{ hibajelzs helyett nil pointer }
function HeapFunc(size:tadat) :integer; far;
 begin
   heapfunc:=1;
 end;

{ adat bevitele a verembe }
procedure betesz(adat : tadat);
 var
    sv : septr ;
 begin
   new(sv);  { j elem }
   if (sv = nil) then
	           begin
		     writeln(#7'Stack overflow');
		     exit;
	           end;
   if (pteteje = nil) then {res stack}
		        begin
		          pteteje := sv;
		          pteteje^.link := nil;
		          pteteje^.info := adat;
		        end
	              else
		        begin {nem res}
		          sv^.link   := pteteje;
		          sv^.info   := adat;
		          pteteje    := sv;
		        end;
    writeln(adat:6, ' bevitele megtrtnt.');
 end;

{ adat kivtele a verembl}
function kivesz(var adat : tadat) : boolean;
 var
  sv : septr ;
 begin
  if (pteteje = nil) then
	               begin
		         writeln(#7'Stack underflow');
		         exit;
                       end;
  sv      := pteteje;
  adat    := pteteje^.info;
  pteteje := pteteje^.link;
  dispose(sv);
  writeln(adat:6, ' kivtele megtrtnt.');
end;

{ a fprogram }
var
  adatelem : tadat;
         i : integer;
begin
  HeapError:=@HeapFunc;

  clrscr;
  { adatok bevitele a verembe }
  for i := 1 to 4 do
     betesz(i*i);

  writeln;
  { adatok kivtele a verembl}
  for i := 1 to  2 do
     kivesz(adatelem);

  writeln;
  { adatok bevitele a verembe }
  for i := 10 to 13 do
     betesz(i*i);

  writeln;
  { adatok kivtele a verembl}
  for i := 1 to  7 do
     kivesz(adatelem);

end.



