(* ASMPROC.PAS *)

program asm_proc;
uses crt;

procedure FillScreen(chr: char; attr: byte); assembler;
  const scrseg = $b800;  { a kpernypuffer szegmense }
        meret  = 2000;   { 2000 sz a mrete }
  asm
    mov al,chr
    mov ah,attr
    mov cx,meret       { 2000 sz }
    mov di,scrseg      { a kpernypuffer szegmense }
    mov es,di
    xor di,di          { 0 ofszet }
    cld
    rep stosw
  end;

var i:integer;
    betu, hatter : integer;
begin
 randomize;
 for i:=1 to 26 do
  begin
    betu:=1+random(15);
    repeat
      hatter:=random(8);
    until hatter<>betu;
    FillScreen(chr(64+i), betu+16*hatter);
    delay(400);
  end;
  clrscr;
end.

