(* INLINEPR.PAS *)

program inline_proc;
uses crt;

{ Plda az inline utasts hasznlatra }

procedure FillScreen(chr: char; attr: byte);
  const scrseg = $b800;  { a kpernypuffer szegmense }
        meret  = 2000;   { 2000 sz a mrete }
  begin
    inline(
       $8A/$46/<chr/
       $8A/$66/<attr/
       $B9/meret/
       $BF/scrseg/
       $8E/$C7/
       $33/$FF/
       $FC/
       $F3/$AB
    )
  end;

{ Pldk az inline derektva hasznlatra }

function makeword(lo, hi : byte): word;
    inline(
       $5A/    { pop ax }
       $58/    { pop dx }
       $88/$D4 { mov ah,dl }
       );

procedure CLI;	{a hardver megszaktsok tiltsa}
   inline($FA);

procedure STI;	{a hardver megszaktsok engedlyezse}
   inline($FB);     



var i:integer;
    betu, hatter : integer;
begin
 randomize;
 cli;
 for i:=1 to 26 do
  begin
    betu:=1+random(15);
    repeat
      hatter:=random(8);
    until hatter<>betu;
    FillScreen(chr(64+i), betu+16*hatter);
    delay(400);
  end;
  sti;

  clrscr;
  for i:=1 to 10 do
   begin
     write(makeword(i,0):10, makeword(0,i):10);
     writeln(makeword(i,i):10);
   end;
end.

