(* pt4.pas *)

{ Decimlis szmok tvltsa 2..32 alap szmrendszerbe }

program pt4;

type emutato = ^elem;
     elem   =  record
                  szamjegy : byte;
                  elozo    : emutato;
               end;

var  alap, i : integer;
     szam    : longint;
     verem, seged : emutato;
     jegyek : array[0..31] of char;

begin
  { a lehetsges szmjegyeket tartalmaz tmb feltltse: }
  for i:=0  to  9 do jegyek[i]:=chr(48+i);
  for i:=10 to 31 do jegyek[i]:=chr(55+i);

  write('Krem a szmrendszer alapjt:',#9);
  readln(alap);
  if not (alap in [2..32]) then halt;

  write('Az tvltand szm:', #9#9);
  readln(szam);

  { a maradkok elhelyezse a veremben, a helyfoglals elvgzsvel: }
  verem:=nil;
  while szam<>0 do
  begin
      new(seged);
      seged^.szamjegy:= szam mod alap;
      seged^.elozo   := verem;
      verem:= seged;
      szam:= szam div alap;
  end;

  { a szm kirsa a verembl trtn visszaolvasssal: }
  write('A(z) ', alap:2, ' szmrendszerbeli alak:',#9);
  seged:= verem;
  while seged<>nil do
  begin
     write(jegyek[seged^.szamjegy]:1);
     seged:= seged^.elozo;
  end;
  writeln(#13#13);

  { a verem ltal lefoglalt memriaterlet felszabadtsa: }
  seged:= verem;
  while seged<>nil do
    begin
      verem := seged^.elozo;
      dispose(seged);
      seged:= verem;
    end;
end.

