(* ovrstart.pas *)

unit ovrstart;

interface

implementation
uses overlay;
var
  ovrhiba:boolean;
  ovrhstr:string;
begin
  ovrinit('ovrtest.ovr');
  ovrhiba:=true;
  case ovrresult of
    ovrerror    : ovrhstr:='Definilatlan hiba';
    ovrnotfound : ovrhstr:='Az overlay file nem tallhat';
    ovrnomemory : ovrhstr:='Nincs elg memria';
    ovrIOerror  : ovrhstr:='Az overlay file olvassi hiba';
    ovrnoEMSdriver : ovrhstr:='Az EMS driver nincs betltve';
    ovrnoEMSmemory : ovrhstr:='Az EMS memria mrete kicsi';
    else
     ovrhiba:=false;
  end;
  if ovrhiba then
     begin
       writeln('OVR Hiba: ',ovrhstr);
       halt;
     end;
end.
