(* wdirtree.pas *)

program wdirtree;

uses crt, windos, strings;

const ch : char = #32;

{ a fjlattribtumokat kir eljrs}
procedure writeattr(fn : string);
 const
   attrstr:string[6]='RHSVDA';
 var
   fp  : file;
   i   : integer;
   as  : string[7];
   attr: word;
 begin
   assign(fp,fn);
   getfattr(fp,attr);
   as:='[';
   for i:=1 to 6 do
     if (attr and (1 shl (i-1)))<>0 then as:=as+attrstr[i]
                                    else as:=as+'.';
   write(as,']');
 end;

{ a fjl ellenrzse a megadott knyvtrban }
procedure checkfile(fnev : pchar);
 var dirinfo: TSearchrec;
 begin
   FindFirst(fnev, faAnyFile, dirinfo);
   while DosError = 0 do
   begin
     if dirinfo.name[1]<>'.' then
        begin
           write('.....',dirinfo.Name);
           gotoxy(30,wherey); writeattr(dirinfo.name);
        end;
     writeln;
     FindNext(dirinfo);
   end;
 end;

{ a teljes knyvtrstruktra bejrsa rekurzv eljrssal }
procedure keres(dir, fnev : pchar);
 var
   dirinfo: TSearchRec;
   s1, sdir: array[0..fsDirectory] of char;
   sl : integer;
 begin
   if keypressed then ch:=readkey;
   if ch=#27 then exit;

   GetCurDir(s1, 0);
   {$I-}
   SetCurDir(dir);
   {$I+}
   if ioresult<>0 then
       begin
         writeln('Hibs knyvtr: ',dir);
         exit;
       end;
   writeln(dir);
   checkfile(fnev);
   FindFirst('*.*', faAnyfile,dirinfo);
   while DosError = 0 do
   begin
     if dirinfo.name[0]<>'.' then
      begin
        {$I-}
        chdir(strpas(dirinfo.name));
        {$I+}
        if ioresult=0 then
           begin
             sl:=strlen(dir);
             if dir[sl-1]='\' then dir[sl-1]:=#0;
             SetCurDir('..');
             strcopy(sdir, dir);
             strcat(sdir, '\');
             strcat(sdir,dirinfo.Name);
             keres(sdir, fnev);
           end;

      end;
     FindNext(dirinfo);
   end;
  chdir(s1);
 end;

{ A fprogram }
var
  dir0  : array[0..fsDirectory] of char;
  fnev0 : array[0..fsFileName] of char;

begin
assign(output,'');
rewrite(output);
if GetArgCount<2 then
     begin
       writeln;
       writeln('Hasznlat: WDIRTREE knyvtr fjlspec.');
       writeln;
       exit;
     end
     else
       begin
         GetArgStr(dir0,1,fsDirectory);
         GetArgStr(fnev0, 2, fsFileName);
         writeln(dir0, fnev0);
         keres(dir0, fnev0);
       end;
end.

