(* RENDEZ.PAS *)

unit rendez;

interface
   {Keress}
   function  binkeres (var tomb; elem : integer; db : integer) : integer;
   function  sorkeres (var tomb; elem : integer; db : integer) : integer;

   {Rendezs}
   procedure rbuborek (var tomb; db : integer);
   procedure rshell (var tomb; db : integer);
   procedure rgyors (var tomb; db : integer);

implementation

type
  rtomb = array[1..1] of integer;


{--------------------------------------------------------------------------------}
{ loklis eljrs }

  {kt egsz vltozt felcserl}
  procedure csere (var a, b : integer);
  var c : integer;
  begin
     c := a;
     a := b;
     b := c;
  end;

{--------------------------------------------------------------------------------}
{ globlis fggvnyek s eljrsok }

  {--------------------------------------------------------------------------------}
  {binris keress}
  function binkeres (var tomb; elem : integer; db : integer) : integer;
  var felso, also, kozepso : integer;
  begin
    also := 1;
    felso := db;
        while felso >= also do
           begin
              kozepso := trunc(felso + also) div 2;
              if elem > rtomb(tomb)[kozepso]
                 then also := kozepso + 1
                 else if elem < rtomb(tomb)[kozepso]
                         then felso := kozepso - 1
                         else felso := -1;
           end;
        if felso = -1
           then binkeres := kozepso
           else binkeres := 0;
     end;

  {--------------------------------------------------------------------------------}
  {szekvencilis keress}
  function sorkeres (var tomb; elem : integer; db : integer) : integer;
  var i : integer;
  begin
    for i := 1 to db do
      if elem = rtomb(tomb)[i]
         then begin
                sorkeres := i;
                exit;
              end;
    sorkeres := 0;
  end;

  {--------------------------------------------------------------------------------}
  {bubork rendezs}
  procedure rbuborek (var tomb; db : integer);
  var i, j : integer;
  begin
     for i := 2 to db do
       for j := db downto i do
         if rtomb(tomb)[j-1] > rtomb(tomb)[j]
            then csere(rtomb(tomb)[j],rtomb(tomb)[j-1]);
  end;

  {--------------------------------------------------------------------------------}
  {Shell-rendezs}
  procedure rshell (var tomb; db : integer);
  var lepes, i, j, k : integer;
  begin
    lepes := db div 2;
    while (lepes > 0) do
      begin
        for i := (lepes + 1) to db do
          begin
            j := i - lepes;
            while (j > 0) do
              begin
                k := j + lepes;
                if (rtomb(tomb)[j] <= rtomb(tomb)[k])
                   then j := 0
                   else csere(rtomb(tomb)[j],rtomb(tomb)[k]);
                j := j - lepes;
              end;
          end;
        lepes := lepes div 2;
      end;
  end;

  {--------------------------------------------------------------------------------}
  {gyorsrendezs}
  procedure rgyors (var tomb; db : integer);

    Procedure reszrend(var adat; kindex, vindex : word);
        var
          fixelem, selem  : integer;
          bindex,  jindex : word;

        begin
          bindex := kindex;
          jindex := vindex;
          fixelem := rtomb(tomb)[(kindex + vindex) div 2];

          repeat
            { balrl jobbra a nagyobbat }
            while (rtomb(tomb)[bindex] < fixelem) do inc(bindex);
            { jobbrl balra a kisebbet }
            while (fixelem < rtomb(tomb)[jindex]) do dec(jindex);
            { csere }
            if (bindex <= jindex) then
              begin
                 csere(rtomb(tomb)[bindex],rtomb(tomb)[jindex]);
                 inc(bindex);
                 dec(jindex)
              end
          until (bindex > jindex);

          if (kindex < jindex) then
            reszrend(tomb, kindex, jindex);

          if (bindex < vindex) then
            reszrend(tomb, bindex, vindex)
    end;  { reszrend }

  begin
    reszrend(tomb, 1, db);
  end;
  {--------------------------------------------------------------------------------}

 end.
