(* stlist.pas *)

program sztring_lista;

type { a listaelem tpusa }
   pelem = ^telem;
   telem  = record
      adat : string[132];
      ptr  : pelem;
   end;

var
  bptr, sptr, tptr : pelem;
  tf  : text;
  sor : word;

{ hiba esetn itt lp ki a program }
procedure halterr(msg:string);
 begin
   writeln(#7,'Futsi hiba :  ',msg);
   writeln(#7,'a program futsa megszakadt.');
   halt(1);
 end;

{ hibajelzs helyett nil pointer }
function HeapFunc(size:word) :integer; far;
 begin
   heapfunc:=1;
 end;

begin
  HeapError:=@HeapFunc;

  { A paramterezs tesztelse }
  if paramcount<>1 then
    halterr(#13+#10+#13+#10+'Hasznlat: STLIST llomny'+ #13+#10);

  { A fjl megnyitsa}
  assign(tf, paramstr(1));
  {$I-}
  reset(tf);
  {$I+}
  if ioresult<>0 then
     halterr('nem elrhet fjl: '+paramstr(1));

  writeln('A(z) ', paramstr(1), ' llomny megnyitsa sikeres volt.');
  writeln('A lista felptse folyamatban ...');
  sor:=0;
  { a sztringlista felptse, a bptr a lista elejre mutat}
  bptr:=nil;
  while not eof(tf) do
   begin
     { j elem ltrehozsa s feltltse }
     new(tptr);
     if not assigned(tptr) then
                             begin
                               close(tf);
                               halterr('Nincs elg memria');
                             end;
     readln(tf,tptr^.adat);
     inc(sor);
     tptr^.ptr := nil;

     { a lnc ptse }
     if bptr=nil then bptr:=tptr         { ha els elem }
                 else sptr^.ptr := tptr; { nem els elem }
     sptr := tptr;
   end;
   close(tf);
   writeln('A lista ksz van!');
   writeln('A beolvasott sorok szma: ', sor:5);
   writeln;
   writeln ('A listzshoz nyomja meg az <Enter> billentyt!');
   readln;

   { a lista vgigjrsa az elemek kiiratsval }
   sptr:=bptr;
   repeat
     writeln(sptr^.adat);
     sptr := sptr^.ptr;
   until sptr=nil;

   { a lista felszabadtsa }
   sptr:=bptr;
   repeat
     tptr := sptr^.ptr; { a kvetkez elem }
     dispose(sptr);     { az aktulis felszabadtsa }
     sptr := tptr;      { tovbblp }
   until sptr=nil;

end.