(* oszlop.pas *)
program oszlop_diagram;
uses crt,graph;
const  l=50;
type
     tomb = array[1..l] of real;
var
     y           : tomb;
     n           : integer;
     i           : integer;
     fsz         : string;

procedure oszlop(t:tomb; k:integer; sz: string);
var i          :integer;
    tmax,tmin  : real;
    gd,gm      : integer;
    color      : array[1..3] of integer;
    xm,ym      : integer;
    m          : integer;
    snorm      : real;
    tsz        : integer;
    xx1,yy1    : integer;
    xx2,yy2    : integer;
    yact       : integer;
    szam,szam1 : string[6];
    dx         : integer;
    x1,y1,x2,y2: integer;

procedure max_kereses(t: tomb; k: integer;var tmax: real;var tmin:real);
var i: integer;
begin
    tmax:=t[1];
    tmin:=t[1];
    for i:=2 to k do
    begin
      if t[i]>tmax then tmax:=t[i];
      if t[i]<tmin then tmin:=t[i];
    end;
end;

begin
   max_kereses(t,k,tmax,tmin);
   DetectGraph(gd,gm);
   case gd of
    CGA: begin
          gm:=CGAC1;
          xm:=319;
          ym:=199;
          color[1]:=1;
          color[2]:=2;
          color[3]:=3;
         end;
    EGA: begin
          gm:=EGALO;
          xm:=639;
          ym:=199;
          color[1]:=cyan;
          color[2]:=lightred;
          color[3]:=blue;
         end;
    VGA: begin
          gm:=VGALO;
          xm:=639;
          ym:=199;
          color[1]:=cyan;
          color[2]:=lightred;
          color[3]:=blue;
         end;
   end;
   initgraph(gd,gm,'');
   setcolor(color[1]);
   if gd=1 then setbkcolor(black) else
           setbkcolor(white);
   settextjustify(Centertext,Centertext);
   setcolor(1);
   outtextxy(xm div 2,10,sz);
   x1:=40;
   y1:=30;
   x2:=xm-20;
   y2:=ym-15;
   if gd=1 then begin
   x1:=10; x2:=xm-10; end;
   setcolor(color[3]);
   settextjustify(LeftText,BottomText);
      str(tmax:6:0,szam);
      str(tmin:6:0,szam1);
   outtextxy(x1,28,'minimum: '+szam1+'    maximum: '+szam);

   m:=y2-y1-2;
   snorm:=m/tmax;
   yact:=y2-y1;
   if gd=1 then tsz:=(x2-x1-1) div k else tsz :=(x2-x1-1) div k;
   setcolor(2);
   if gd=1 then begin xx2:=x1+2; tsz:=tsz-3; dx:=3; end else
                begin xx2:=x1+2; tsz:=tsz-4; dx:=4; end;
       x2:=x1+ k*(tsz+dx)+dx+2;
   setcolor(color[1]);
   rectangle(x1,y1,x2,y2+2);

   setfillStyle(1,color[2]);
   for i:=1 to k do
   begin
      xx1:=xx2+dx;
      yy1:=y1+yact-round(y[i]*snorm);
      xx2:=xx1+tsz;
      yy2:=y1+round(y[i]*snorm);
      setcolor(1);

      bar(xx1,yy1,xx2,y2);
      rectangle(xx1,yy1,xx2,y2);
      str(i:2,szam);
      setcolor(color[1]);
    if gd=1 then begin
                  if k<25 then begin
                   SetTextStyle(SmallFont,HorizDir,1);
                   SetUserCharSize(13,12,14,17);
                   outtextxy(xx1+1,y2+10,szam);
                   end
                 end
                 else
   if k<31 then  outtextxy(xx1+5,y2+12,szam);
   end;
   if ((gd=1) and (k>24)) or ((gd<>1) and (k>30)) then
                      begin
                         outtextxy(x1+3,y2+13,'1');
                         str(k:3,szam);
                         outtextxy(xx2-22,y2+13,szam);
                      end;

   readln;
   closegraph;
end;

begin
   writeln('Adatok beolvassa ');
  repeat
   write('Az adatok szma : '); readln(n);
   writeln;
  until n<=50;
   for i:=1 to n do
   begin
     write(i:2,'. adat : ');  readln(y[i]);
   end;
   write('A diagram fejlce : '); readln(fsz);
   oszlop(y,n,fsz);
end.