(* tsr_pld.pas *)
{$M $800,0,0 }   { 2K stack, nincs heap }
program tsr_pld;
uses Crt, Dos;
var
  oldit_09  : Procedure;
  sc        : byte;
  on_off    : boolean;
  al,ah     : byte;

{Inline eljrs - a PUSHF gpikd utasts}
procedure PUSHF; inline ($9C);

{ Az j megszaktskezel eljrs }
procedure newit_09; interrupt;
 begin
   { A scankd beolvassa }
   sc:=port[$60];
   if sc=1 then
     begin
      if (mem[0:$417] and $04)<>0 then
          {A CTRL-ESC kombinci hatsra ki-/bekapcsol}
          begin
              on_off:= not on_off;

              {A billentyzet vezrl programozsa}
              al:=port[$61];
              ah:=al or $80;
              port[$61]:=ah;
              port[$61]:=al;

              {A megszakts vezrl programozsa}
              port[$20]:=$20;
              exit;
          end;
    end;
   {Ha be van kapcsolva s lenyomtak billenyt}
   if on_off and (sc<$80) then
    begin
     {Hanggenerls}
     sound( Abs(880 + 60 * sc)) ;
     Delay(10);
     Nosound;
     end;
   { A rgi megszakts rutin hvsa }
   PUSHF;
   oldit_09;
 end;

begin
  on_off:=false;
  {A rgi belpsi pont lekrdezse}
  GetIntVec($9,@oldit_09);
  {Az IT-cm sajt terletre lltsa}
  SetIntVec($9,Addr(newit_09));
  {TSR -  rezidens kilps a programbl }
  Keep(0);
end.

